
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN"
  "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">

<html xmlns="http://www.w3.org/1999/xhtml" lang="en">
  <head>
    <meta http-equiv="X-UA-Compatible" content="IE=Edge" />
    <meta http-equiv="Content-Type" content="text/html; charset=utf-8" />
    <title>sortedcontainers.sortedset &#8212; EMULSION (Epidemiological Multi-Level Simulation framework)</title>
    <link rel="stylesheet" href="../../_static/alabaster.css" type="text/css" />
    <link rel="stylesheet" href="../../_static/pygments.css" type="text/css" />
    <link rel="stylesheet" href="../../_static/css/custom.css" type="text/css" />
    <script type="text/javascript" id="documentation_options" data-url_root="../../" src="../../_static/documentation_options.js"></script>
    <script type="text/javascript" src="../../_static/jquery.js"></script>
    <script type="text/javascript" src="../../_static/underscore.js"></script>
    <script type="text/javascript" src="../../_static/doctools.js"></script>
    <script type="text/javascript" src="../../_static/language_data.js"></script>
    <script async="async" type="text/javascript" src="https://cdnjs.cloudflare.com/ajax/libs/mathjax/2.7.5/latest.js?config=TeX-AMS-MML_HTMLorMML"></script>
    <link rel="shortcut icon" href="../../_static/STEMAH-favicon.png"/>
    <link rel="index" title="Index" href="../../genindex.html" />
    <link rel="search" title="Search" href="../../search.html" />
   
  <link rel="stylesheet" href="../../_static/custom.css" type="text/css" />
  
  
  <meta name="viewport" content="width=device-width, initial-scale=0.9, maximum-scale=0.9" />

  </head><body>
  

    <div class="document">
      <div class="documentwrapper">
        <div class="bodywrapper">
          <div class="body" role="main">
            
  <h1>Source code for sortedcontainers.sortedset</h1><div class="highlight"><pre>
<span></span><span class="sd">&quot;&quot;&quot;Sorted set implementation.</span>

<span class="sd">&quot;&quot;&quot;</span>

<span class="kn">from</span> <span class="nn">collections</span> <span class="k">import</span> <span class="n">Set</span><span class="p">,</span> <span class="n">MutableSet</span><span class="p">,</span> <span class="n">Sequence</span>
<span class="kn">from</span> <span class="nn">itertools</span> <span class="k">import</span> <span class="n">chain</span>
<span class="kn">import</span> <span class="nn">operator</span> <span class="k">as</span> <span class="nn">op</span>

<span class="kn">from</span> <span class="nn">.sortedlist</span> <span class="k">import</span> <span class="n">SortedList</span><span class="p">,</span> <span class="n">recursive_repr</span><span class="p">,</span> <span class="n">SortedListWithKey</span>

<span class="k">class</span> <span class="nc">SortedSet</span><span class="p">(</span><span class="n">MutableSet</span><span class="p">,</span> <span class="n">Sequence</span><span class="p">):</span>
    <span class="sd">&quot;&quot;&quot;</span>
<span class="sd">    A `SortedSet` provides the same methods as a `set`.  Additionally, a</span>
<span class="sd">    `SortedSet` maintains its items in sorted order, allowing the `SortedSet` to</span>
<span class="sd">    be indexed.</span>

<span class="sd">    Unlike a `set`, a `SortedSet` requires items be hashable and comparable.</span>
<span class="sd">    &quot;&quot;&quot;</span>
    <span class="k">def</span> <span class="nf">__init__</span><span class="p">(</span><span class="bp">self</span><span class="p">,</span> <span class="n">iterable</span><span class="o">=</span><span class="kc">None</span><span class="p">,</span> <span class="n">key</span><span class="o">=</span><span class="kc">None</span><span class="p">,</span> <span class="n">load</span><span class="o">=</span><span class="mi">1000</span><span class="p">,</span> <span class="n">_set</span><span class="o">=</span><span class="kc">None</span><span class="p">):</span>
        <span class="sd">&quot;&quot;&quot;</span>
<span class="sd">        A `SortedSet` provides the same methods as a `set`.  Additionally, a</span>
<span class="sd">        `SortedSet` maintains its items in sorted order, allowing the</span>
<span class="sd">        `SortedSet` to be indexed.</span>

<span class="sd">        An optional *iterable* provides an initial series of items to populate</span>
<span class="sd">        the `SortedSet`.</span>

<span class="sd">        An optional *key* argument defines a callable that, like the `key`</span>
<span class="sd">        argument to Python&#39;s `sorted` function, extracts a comparison key from</span>
<span class="sd">        each set item. If no function is specified, the default compares the</span>
<span class="sd">        set items directly.</span>

<span class="sd">        An optional *load* specifies the load-factor of the set. The default</span>
<span class="sd">        load factor of &#39;1000&#39; works well for sets from tens to tens of millions</span>
<span class="sd">        of elements.  Good practice is to use a value that is the cube root of</span>
<span class="sd">        the set size.  With billions of elements, the best load factor depends</span>
<span class="sd">        on your usage.  It&#39;s best to leave the load factor at the default until</span>
<span class="sd">        you start benchmarking.</span>
<span class="sd">        &quot;&quot;&quot;</span>
        <span class="c1"># pylint: disable=redefined-variable-type</span>
        <span class="bp">self</span><span class="o">.</span><span class="n">_key</span> <span class="o">=</span> <span class="n">key</span>
        <span class="bp">self</span><span class="o">.</span><span class="n">_load</span> <span class="o">=</span> <span class="n">load</span>

        <span class="bp">self</span><span class="o">.</span><span class="n">_set</span> <span class="o">=</span> <span class="nb">set</span><span class="p">()</span> <span class="k">if</span> <span class="n">_set</span> <span class="ow">is</span> <span class="kc">None</span> <span class="k">else</span> <span class="n">_set</span>

        <span class="n">_set</span> <span class="o">=</span> <span class="bp">self</span><span class="o">.</span><span class="n">_set</span>
        <span class="bp">self</span><span class="o">.</span><span class="n">isdisjoint</span> <span class="o">=</span> <span class="n">_set</span><span class="o">.</span><span class="n">isdisjoint</span>
        <span class="bp">self</span><span class="o">.</span><span class="n">issubset</span> <span class="o">=</span> <span class="n">_set</span><span class="o">.</span><span class="n">issubset</span>
        <span class="bp">self</span><span class="o">.</span><span class="n">issuperset</span> <span class="o">=</span> <span class="n">_set</span><span class="o">.</span><span class="n">issuperset</span>

        <span class="k">if</span> <span class="n">key</span> <span class="ow">is</span> <span class="kc">None</span><span class="p">:</span>
            <span class="bp">self</span><span class="o">.</span><span class="n">_list</span> <span class="o">=</span> <span class="n">SortedList</span><span class="p">(</span><span class="bp">self</span><span class="o">.</span><span class="n">_set</span><span class="p">,</span> <span class="n">load</span><span class="o">=</span><span class="n">load</span><span class="p">)</span>
        <span class="k">else</span><span class="p">:</span>
            <span class="bp">self</span><span class="o">.</span><span class="n">_list</span> <span class="o">=</span> <span class="n">SortedListWithKey</span><span class="p">(</span><span class="bp">self</span><span class="o">.</span><span class="n">_set</span><span class="p">,</span> <span class="n">key</span><span class="o">=</span><span class="n">key</span><span class="p">,</span> <span class="n">load</span><span class="o">=</span><span class="n">load</span><span class="p">)</span>

        <span class="n">_list</span> <span class="o">=</span> <span class="bp">self</span><span class="o">.</span><span class="n">_list</span>
        <span class="bp">self</span><span class="o">.</span><span class="n">bisect_left</span> <span class="o">=</span> <span class="n">_list</span><span class="o">.</span><span class="n">bisect_left</span>
        <span class="bp">self</span><span class="o">.</span><span class="n">bisect</span> <span class="o">=</span> <span class="n">_list</span><span class="o">.</span><span class="n">bisect</span>
        <span class="bp">self</span><span class="o">.</span><span class="n">bisect_right</span> <span class="o">=</span> <span class="n">_list</span><span class="o">.</span><span class="n">bisect_right</span>
        <span class="bp">self</span><span class="o">.</span><span class="n">index</span> <span class="o">=</span> <span class="n">_list</span><span class="o">.</span><span class="n">index</span>
        <span class="bp">self</span><span class="o">.</span><span class="n">irange</span> <span class="o">=</span> <span class="n">_list</span><span class="o">.</span><span class="n">irange</span>
        <span class="bp">self</span><span class="o">.</span><span class="n">islice</span> <span class="o">=</span> <span class="n">_list</span><span class="o">.</span><span class="n">islice</span>

        <span class="k">if</span> <span class="n">key</span> <span class="ow">is</span> <span class="ow">not</span> <span class="kc">None</span><span class="p">:</span>
            <span class="bp">self</span><span class="o">.</span><span class="n">bisect_key_left</span> <span class="o">=</span> <span class="n">_list</span><span class="o">.</span><span class="n">bisect_key_left</span>
            <span class="bp">self</span><span class="o">.</span><span class="n">bisect_key_right</span> <span class="o">=</span> <span class="n">_list</span><span class="o">.</span><span class="n">bisect_key_right</span>
            <span class="bp">self</span><span class="o">.</span><span class="n">bisect_key</span> <span class="o">=</span> <span class="n">_list</span><span class="o">.</span><span class="n">bisect_key</span>
            <span class="bp">self</span><span class="o">.</span><span class="n">irange_key</span> <span class="o">=</span> <span class="n">_list</span><span class="o">.</span><span class="n">irange_key</span>

        <span class="k">if</span> <span class="n">iterable</span> <span class="ow">is</span> <span class="ow">not</span> <span class="kc">None</span><span class="p">:</span>
            <span class="bp">self</span><span class="o">.</span><span class="n">_update</span><span class="p">(</span><span class="n">iterable</span><span class="p">)</span>

    <span class="k">def</span> <span class="nf">__contains__</span><span class="p">(</span><span class="bp">self</span><span class="p">,</span> <span class="n">value</span><span class="p">):</span>
        <span class="sd">&quot;&quot;&quot;Return True if and only if *value* is an element in the set.&quot;&quot;&quot;</span>
        <span class="k">return</span> <span class="n">value</span> <span class="ow">in</span> <span class="bp">self</span><span class="o">.</span><span class="n">_set</span>

    <span class="k">def</span> <span class="nf">__getitem__</span><span class="p">(</span><span class="bp">self</span><span class="p">,</span> <span class="n">index</span><span class="p">):</span>
        <span class="sd">&quot;&quot;&quot;</span>
<span class="sd">        Return the element at position *index*.</span>

<span class="sd">        Supports slice notation and negative indexes.</span>
<span class="sd">        &quot;&quot;&quot;</span>
        <span class="k">return</span> <span class="bp">self</span><span class="o">.</span><span class="n">_list</span><span class="p">[</span><span class="n">index</span><span class="p">]</span>

    <span class="k">def</span> <span class="nf">__delitem__</span><span class="p">(</span><span class="bp">self</span><span class="p">,</span> <span class="n">index</span><span class="p">):</span>
        <span class="sd">&quot;&quot;&quot;</span>
<span class="sd">        Remove the element at position *index*.</span>

<span class="sd">        Supports slice notation and negative indexes.</span>
<span class="sd">        &quot;&quot;&quot;</span>
        <span class="n">_set</span> <span class="o">=</span> <span class="bp">self</span><span class="o">.</span><span class="n">_set</span>
        <span class="n">_list</span> <span class="o">=</span> <span class="bp">self</span><span class="o">.</span><span class="n">_list</span>
        <span class="k">if</span> <span class="nb">isinstance</span><span class="p">(</span><span class="n">index</span><span class="p">,</span> <span class="nb">slice</span><span class="p">):</span>
            <span class="n">values</span> <span class="o">=</span> <span class="n">_list</span><span class="p">[</span><span class="n">index</span><span class="p">]</span>
            <span class="n">_set</span><span class="o">.</span><span class="n">difference_update</span><span class="p">(</span><span class="n">values</span><span class="p">)</span>
        <span class="k">else</span><span class="p">:</span>
            <span class="n">value</span> <span class="o">=</span> <span class="n">_list</span><span class="p">[</span><span class="n">index</span><span class="p">]</span>
            <span class="n">_set</span><span class="o">.</span><span class="n">remove</span><span class="p">(</span><span class="n">value</span><span class="p">)</span>
        <span class="k">del</span> <span class="n">_list</span><span class="p">[</span><span class="n">index</span><span class="p">]</span>

    <span class="k">def</span> <span class="nf">_make_cmp</span><span class="p">(</span><span class="bp">self</span><span class="p">,</span> <span class="n">set_op</span><span class="p">,</span> <span class="n">doc</span><span class="p">):</span>
        <span class="s2">&quot;Make comparator method.&quot;</span>
        <span class="k">def</span> <span class="nf">comparer</span><span class="p">(</span><span class="bp">self</span><span class="p">,</span> <span class="n">that</span><span class="p">):</span>
            <span class="s2">&quot;Compare method for sorted set and set-like object.&quot;</span>
            <span class="c1"># pylint: disable=protected-access</span>
            <span class="k">if</span> <span class="nb">isinstance</span><span class="p">(</span><span class="n">that</span><span class="p">,</span> <span class="n">SortedSet</span><span class="p">):</span>
                <span class="k">return</span> <span class="n">set_op</span><span class="p">(</span><span class="bp">self</span><span class="o">.</span><span class="n">_set</span><span class="p">,</span> <span class="n">that</span><span class="o">.</span><span class="n">_set</span><span class="p">)</span>
            <span class="k">elif</span> <span class="nb">isinstance</span><span class="p">(</span><span class="n">that</span><span class="p">,</span> <span class="n">Set</span><span class="p">):</span>
                <span class="k">return</span> <span class="n">set_op</span><span class="p">(</span><span class="bp">self</span><span class="o">.</span><span class="n">_set</span><span class="p">,</span> <span class="n">that</span><span class="p">)</span>
            <span class="k">else</span><span class="p">:</span>
                <span class="k">return</span> <span class="bp">NotImplemented</span>

        <span class="n">comparer</span><span class="o">.</span><span class="vm">__name__</span> <span class="o">=</span> <span class="s1">&#39;__</span><span class="si">{0}</span><span class="s1">__&#39;</span><span class="o">.</span><span class="n">format</span><span class="p">(</span><span class="n">set_op</span><span class="o">.</span><span class="vm">__name__</span><span class="p">)</span>
        <span class="n">doc_str</span> <span class="o">=</span> <span class="s1">&#39;Return True if and only if Set is </span><span class="si">{0}</span><span class="s1"> `that`.&#39;</span>
        <span class="n">comparer</span><span class="o">.</span><span class="vm">__doc__</span> <span class="o">=</span> <span class="n">doc_str</span><span class="o">.</span><span class="n">format</span><span class="p">(</span><span class="n">doc</span><span class="p">)</span>

        <span class="k">return</span> <span class="n">comparer</span>

    <span class="fm">__eq__</span> <span class="o">=</span> <span class="n">_make_cmp</span><span class="p">(</span><span class="kc">None</span><span class="p">,</span> <span class="n">op</span><span class="o">.</span><span class="n">eq</span><span class="p">,</span> <span class="s1">&#39;equal to&#39;</span><span class="p">)</span>
    <span class="fm">__ne__</span> <span class="o">=</span> <span class="n">_make_cmp</span><span class="p">(</span><span class="kc">None</span><span class="p">,</span> <span class="n">op</span><span class="o">.</span><span class="n">ne</span><span class="p">,</span> <span class="s1">&#39;not equal to&#39;</span><span class="p">)</span>
    <span class="fm">__lt__</span> <span class="o">=</span> <span class="n">_make_cmp</span><span class="p">(</span><span class="kc">None</span><span class="p">,</span> <span class="n">op</span><span class="o">.</span><span class="n">lt</span><span class="p">,</span> <span class="s1">&#39;a proper subset of&#39;</span><span class="p">)</span>
    <span class="fm">__gt__</span> <span class="o">=</span> <span class="n">_make_cmp</span><span class="p">(</span><span class="kc">None</span><span class="p">,</span> <span class="n">op</span><span class="o">.</span><span class="n">gt</span><span class="p">,</span> <span class="s1">&#39;a proper superset of&#39;</span><span class="p">)</span>
    <span class="fm">__le__</span> <span class="o">=</span> <span class="n">_make_cmp</span><span class="p">(</span><span class="kc">None</span><span class="p">,</span> <span class="n">op</span><span class="o">.</span><span class="n">le</span><span class="p">,</span> <span class="s1">&#39;a subset of&#39;</span><span class="p">)</span>
    <span class="fm">__ge__</span> <span class="o">=</span> <span class="n">_make_cmp</span><span class="p">(</span><span class="kc">None</span><span class="p">,</span> <span class="n">op</span><span class="o">.</span><span class="n">ge</span><span class="p">,</span> <span class="s1">&#39;a superset of&#39;</span><span class="p">)</span>

    <span class="k">def</span> <span class="nf">__len__</span><span class="p">(</span><span class="bp">self</span><span class="p">):</span>
        <span class="sd">&quot;&quot;&quot;Return the number of elements in the set.&quot;&quot;&quot;</span>
        <span class="k">return</span> <span class="nb">len</span><span class="p">(</span><span class="bp">self</span><span class="o">.</span><span class="n">_set</span><span class="p">)</span>

    <span class="k">def</span> <span class="nf">__iter__</span><span class="p">(</span><span class="bp">self</span><span class="p">):</span>
        <span class="sd">&quot;&quot;&quot;</span>
<span class="sd">        Return an iterator over the Set. Elements are iterated in their sorted</span>
<span class="sd">        order.</span>

<span class="sd">        Iterating the Set while adding or deleting values may raise a</span>
<span class="sd">        `RuntimeError` or fail to iterate over all entries.</span>
<span class="sd">        &quot;&quot;&quot;</span>
        <span class="k">return</span> <span class="nb">iter</span><span class="p">(</span><span class="bp">self</span><span class="o">.</span><span class="n">_list</span><span class="p">)</span>

    <span class="k">def</span> <span class="nf">__reversed__</span><span class="p">(</span><span class="bp">self</span><span class="p">):</span>
        <span class="sd">&quot;&quot;&quot;</span>
<span class="sd">        Return an iterator over the Set. Elements are iterated in their reverse</span>
<span class="sd">        sorted order.</span>

<span class="sd">        Iterating the Set while adding or deleting values may raise a</span>
<span class="sd">        `RuntimeError` or fail to iterate over all entries.</span>
<span class="sd">        &quot;&quot;&quot;</span>
        <span class="k">return</span> <span class="nb">reversed</span><span class="p">(</span><span class="bp">self</span><span class="o">.</span><span class="n">_list</span><span class="p">)</span>

    <span class="k">def</span> <span class="nf">add</span><span class="p">(</span><span class="bp">self</span><span class="p">,</span> <span class="n">value</span><span class="p">):</span>
        <span class="sd">&quot;&quot;&quot;Add the element *value* to the set.&quot;&quot;&quot;</span>
        <span class="n">_set</span> <span class="o">=</span> <span class="bp">self</span><span class="o">.</span><span class="n">_set</span>
        <span class="k">if</span> <span class="n">value</span> <span class="ow">not</span> <span class="ow">in</span> <span class="n">_set</span><span class="p">:</span>
            <span class="n">_set</span><span class="o">.</span><span class="n">add</span><span class="p">(</span><span class="n">value</span><span class="p">)</span>
            <span class="bp">self</span><span class="o">.</span><span class="n">_list</span><span class="o">.</span><span class="n">add</span><span class="p">(</span><span class="n">value</span><span class="p">)</span>

    <span class="k">def</span> <span class="nf">clear</span><span class="p">(</span><span class="bp">self</span><span class="p">):</span>
        <span class="sd">&quot;&quot;&quot;Remove all elements from the set.&quot;&quot;&quot;</span>
        <span class="bp">self</span><span class="o">.</span><span class="n">_set</span><span class="o">.</span><span class="n">clear</span><span class="p">()</span>
        <span class="bp">self</span><span class="o">.</span><span class="n">_list</span><span class="o">.</span><span class="n">clear</span><span class="p">()</span>

    <span class="k">def</span> <span class="nf">copy</span><span class="p">(</span><span class="bp">self</span><span class="p">):</span>
        <span class="sd">&quot;&quot;&quot;Create a shallow copy of the sorted set.&quot;&quot;&quot;</span>
        <span class="k">return</span> <span class="bp">self</span><span class="o">.</span><span class="vm">__class__</span><span class="p">(</span><span class="n">key</span><span class="o">=</span><span class="bp">self</span><span class="o">.</span><span class="n">_key</span><span class="p">,</span> <span class="n">load</span><span class="o">=</span><span class="bp">self</span><span class="o">.</span><span class="n">_load</span><span class="p">,</span> <span class="n">_set</span><span class="o">=</span><span class="nb">set</span><span class="p">(</span><span class="bp">self</span><span class="o">.</span><span class="n">_set</span><span class="p">))</span>

    <span class="n">__copy__</span> <span class="o">=</span> <span class="n">copy</span>

    <span class="k">def</span> <span class="nf">count</span><span class="p">(</span><span class="bp">self</span><span class="p">,</span> <span class="n">value</span><span class="p">):</span>
        <span class="sd">&quot;&quot;&quot;Return the number of occurrences of *value* in the set.&quot;&quot;&quot;</span>
        <span class="k">return</span> <span class="mi">1</span> <span class="k">if</span> <span class="n">value</span> <span class="ow">in</span> <span class="bp">self</span><span class="o">.</span><span class="n">_set</span> <span class="k">else</span> <span class="mi">0</span>

    <span class="k">def</span> <span class="nf">discard</span><span class="p">(</span><span class="bp">self</span><span class="p">,</span> <span class="n">value</span><span class="p">):</span>
        <span class="sd">&quot;&quot;&quot;</span>
<span class="sd">        Remove the first occurrence of *value*.  If *value* is not a member,</span>
<span class="sd">        does nothing.</span>
<span class="sd">        &quot;&quot;&quot;</span>
        <span class="n">_set</span> <span class="o">=</span> <span class="bp">self</span><span class="o">.</span><span class="n">_set</span>
        <span class="k">if</span> <span class="n">value</span> <span class="ow">in</span> <span class="n">_set</span><span class="p">:</span>
            <span class="n">_set</span><span class="o">.</span><span class="n">remove</span><span class="p">(</span><span class="n">value</span><span class="p">)</span>
            <span class="bp">self</span><span class="o">.</span><span class="n">_list</span><span class="o">.</span><span class="n">discard</span><span class="p">(</span><span class="n">value</span><span class="p">)</span>

    <span class="k">def</span> <span class="nf">pop</span><span class="p">(</span><span class="bp">self</span><span class="p">,</span> <span class="n">index</span><span class="o">=-</span><span class="mi">1</span><span class="p">):</span>
        <span class="sd">&quot;&quot;&quot;</span>
<span class="sd">        Remove and return item at *index* (default last).  Raises IndexError if</span>
<span class="sd">        set is empty or index is out of range.  Negative indexes are supported,</span>
<span class="sd">        as for slice indices.</span>
<span class="sd">        &quot;&quot;&quot;</span>
        <span class="c1"># pylint: disable=arguments-differ</span>
        <span class="n">value</span> <span class="o">=</span> <span class="bp">self</span><span class="o">.</span><span class="n">_list</span><span class="o">.</span><span class="n">pop</span><span class="p">(</span><span class="n">index</span><span class="p">)</span>
        <span class="bp">self</span><span class="o">.</span><span class="n">_set</span><span class="o">.</span><span class="n">remove</span><span class="p">(</span><span class="n">value</span><span class="p">)</span>
        <span class="k">return</span> <span class="n">value</span>

    <span class="k">def</span> <span class="nf">remove</span><span class="p">(</span><span class="bp">self</span><span class="p">,</span> <span class="n">value</span><span class="p">):</span>
        <span class="sd">&quot;&quot;&quot;</span>
<span class="sd">        Remove first occurrence of *value*.  Raises ValueError if</span>
<span class="sd">        *value* is not present.</span>
<span class="sd">        &quot;&quot;&quot;</span>
        <span class="bp">self</span><span class="o">.</span><span class="n">_set</span><span class="o">.</span><span class="n">remove</span><span class="p">(</span><span class="n">value</span><span class="p">)</span>
        <span class="bp">self</span><span class="o">.</span><span class="n">_list</span><span class="o">.</span><span class="n">remove</span><span class="p">(</span><span class="n">value</span><span class="p">)</span>

    <span class="k">def</span> <span class="nf">difference</span><span class="p">(</span><span class="bp">self</span><span class="p">,</span> <span class="o">*</span><span class="n">iterables</span><span class="p">):</span>
        <span class="sd">&quot;&quot;&quot;</span>
<span class="sd">        Return a new set with elements in the set that are not in the</span>
<span class="sd">        *iterables*.</span>
<span class="sd">        &quot;&quot;&quot;</span>
        <span class="n">diff</span> <span class="o">=</span> <span class="bp">self</span><span class="o">.</span><span class="n">_set</span><span class="o">.</span><span class="n">difference</span><span class="p">(</span><span class="o">*</span><span class="n">iterables</span><span class="p">)</span>
        <span class="n">new_set</span> <span class="o">=</span> <span class="bp">self</span><span class="o">.</span><span class="vm">__class__</span><span class="p">(</span><span class="n">key</span><span class="o">=</span><span class="bp">self</span><span class="o">.</span><span class="n">_key</span><span class="p">,</span> <span class="n">load</span><span class="o">=</span><span class="bp">self</span><span class="o">.</span><span class="n">_load</span><span class="p">,</span> <span class="n">_set</span><span class="o">=</span><span class="n">diff</span><span class="p">)</span>
        <span class="k">return</span> <span class="n">new_set</span>

    <span class="fm">__sub__</span> <span class="o">=</span> <span class="n">difference</span>
    <span class="fm">__rsub__</span> <span class="o">=</span> <span class="fm">__sub__</span>

    <span class="k">def</span> <span class="nf">difference_update</span><span class="p">(</span><span class="bp">self</span><span class="p">,</span> <span class="o">*</span><span class="n">iterables</span><span class="p">):</span>
        <span class="sd">&quot;&quot;&quot;</span>
<span class="sd">        Update the set, removing elements found in keeping only elements</span>
<span class="sd">        found in any of the *iterables*.</span>
<span class="sd">        &quot;&quot;&quot;</span>
        <span class="n">_set</span> <span class="o">=</span> <span class="bp">self</span><span class="o">.</span><span class="n">_set</span>
        <span class="n">values</span> <span class="o">=</span> <span class="nb">set</span><span class="p">(</span><span class="n">chain</span><span class="p">(</span><span class="o">*</span><span class="n">iterables</span><span class="p">))</span>
        <span class="k">if</span> <span class="p">(</span><span class="mi">4</span> <span class="o">*</span> <span class="nb">len</span><span class="p">(</span><span class="n">values</span><span class="p">))</span> <span class="o">&gt;</span> <span class="nb">len</span><span class="p">(</span><span class="n">_set</span><span class="p">):</span>
            <span class="n">_list</span> <span class="o">=</span> <span class="bp">self</span><span class="o">.</span><span class="n">_list</span>
            <span class="n">_set</span><span class="o">.</span><span class="n">difference_update</span><span class="p">(</span><span class="n">values</span><span class="p">)</span>
            <span class="n">_list</span><span class="o">.</span><span class="n">clear</span><span class="p">()</span>
            <span class="n">_list</span><span class="o">.</span><span class="n">update</span><span class="p">(</span><span class="n">_set</span><span class="p">)</span>
        <span class="k">else</span><span class="p">:</span>
            <span class="n">_discard</span> <span class="o">=</span> <span class="bp">self</span><span class="o">.</span><span class="n">discard</span>
            <span class="k">for</span> <span class="n">value</span> <span class="ow">in</span> <span class="n">values</span><span class="p">:</span>
                <span class="n">_discard</span><span class="p">(</span><span class="n">value</span><span class="p">)</span>
        <span class="k">return</span> <span class="bp">self</span>

    <span class="fm">__isub__</span> <span class="o">=</span> <span class="n">difference_update</span>

    <span class="k">def</span> <span class="nf">intersection</span><span class="p">(</span><span class="bp">self</span><span class="p">,</span> <span class="o">*</span><span class="n">iterables</span><span class="p">):</span>
        <span class="sd">&quot;&quot;&quot;</span>
<span class="sd">        Return a new set with elements common to the set and all *iterables*.</span>
<span class="sd">        &quot;&quot;&quot;</span>
        <span class="n">comb</span> <span class="o">=</span> <span class="bp">self</span><span class="o">.</span><span class="n">_set</span><span class="o">.</span><span class="n">intersection</span><span class="p">(</span><span class="o">*</span><span class="n">iterables</span><span class="p">)</span>
        <span class="n">new_set</span> <span class="o">=</span> <span class="bp">self</span><span class="o">.</span><span class="vm">__class__</span><span class="p">(</span><span class="n">key</span><span class="o">=</span><span class="bp">self</span><span class="o">.</span><span class="n">_key</span><span class="p">,</span> <span class="n">load</span><span class="o">=</span><span class="bp">self</span><span class="o">.</span><span class="n">_load</span><span class="p">,</span> <span class="n">_set</span><span class="o">=</span><span class="n">comb</span><span class="p">)</span>
        <span class="k">return</span> <span class="n">new_set</span>

    <span class="fm">__and__</span> <span class="o">=</span> <span class="n">intersection</span>
    <span class="fm">__rand__</span> <span class="o">=</span> <span class="fm">__and__</span>

    <span class="k">def</span> <span class="nf">intersection_update</span><span class="p">(</span><span class="bp">self</span><span class="p">,</span> <span class="o">*</span><span class="n">iterables</span><span class="p">):</span>
        <span class="sd">&quot;&quot;&quot;</span>
<span class="sd">        Update the set, keeping only elements found in it and all *iterables*.</span>
<span class="sd">        &quot;&quot;&quot;</span>
        <span class="n">_set</span> <span class="o">=</span> <span class="bp">self</span><span class="o">.</span><span class="n">_set</span>
        <span class="n">_list</span> <span class="o">=</span> <span class="bp">self</span><span class="o">.</span><span class="n">_list</span>
        <span class="n">_set</span><span class="o">.</span><span class="n">intersection_update</span><span class="p">(</span><span class="o">*</span><span class="n">iterables</span><span class="p">)</span>
        <span class="n">_list</span><span class="o">.</span><span class="n">clear</span><span class="p">()</span>
        <span class="n">_list</span><span class="o">.</span><span class="n">update</span><span class="p">(</span><span class="n">_set</span><span class="p">)</span>
        <span class="k">return</span> <span class="bp">self</span>

    <span class="fm">__iand__</span> <span class="o">=</span> <span class="n">intersection_update</span>

    <span class="k">def</span> <span class="nf">symmetric_difference</span><span class="p">(</span><span class="bp">self</span><span class="p">,</span> <span class="n">that</span><span class="p">):</span>
        <span class="sd">&quot;&quot;&quot;</span>
<span class="sd">        Return a new set with elements in either *self* or *that* but not both.</span>
<span class="sd">        &quot;&quot;&quot;</span>
        <span class="n">diff</span> <span class="o">=</span> <span class="bp">self</span><span class="o">.</span><span class="n">_set</span><span class="o">.</span><span class="n">symmetric_difference</span><span class="p">(</span><span class="n">that</span><span class="p">)</span>
        <span class="n">new_set</span> <span class="o">=</span> <span class="bp">self</span><span class="o">.</span><span class="vm">__class__</span><span class="p">(</span><span class="n">key</span><span class="o">=</span><span class="bp">self</span><span class="o">.</span><span class="n">_key</span><span class="p">,</span> <span class="n">load</span><span class="o">=</span><span class="bp">self</span><span class="o">.</span><span class="n">_load</span><span class="p">,</span> <span class="n">_set</span><span class="o">=</span><span class="n">diff</span><span class="p">)</span>
        <span class="k">return</span> <span class="n">new_set</span>

    <span class="fm">__xor__</span> <span class="o">=</span> <span class="n">symmetric_difference</span>
    <span class="fm">__rxor__</span> <span class="o">=</span> <span class="fm">__xor__</span>

    <span class="k">def</span> <span class="nf">symmetric_difference_update</span><span class="p">(</span><span class="bp">self</span><span class="p">,</span> <span class="n">that</span><span class="p">):</span>
        <span class="sd">&quot;&quot;&quot;</span>
<span class="sd">        Update the set, keeping only elements found in either *self* or *that*,</span>
<span class="sd">        but not in both.</span>
<span class="sd">        &quot;&quot;&quot;</span>
        <span class="n">_set</span> <span class="o">=</span> <span class="bp">self</span><span class="o">.</span><span class="n">_set</span>
        <span class="n">_list</span> <span class="o">=</span> <span class="bp">self</span><span class="o">.</span><span class="n">_list</span>
        <span class="n">_set</span><span class="o">.</span><span class="n">symmetric_difference_update</span><span class="p">(</span><span class="n">that</span><span class="p">)</span>
        <span class="n">_list</span><span class="o">.</span><span class="n">clear</span><span class="p">()</span>
        <span class="n">_list</span><span class="o">.</span><span class="n">update</span><span class="p">(</span><span class="n">_set</span><span class="p">)</span>
        <span class="k">return</span> <span class="bp">self</span>

    <span class="fm">__ixor__</span> <span class="o">=</span> <span class="n">symmetric_difference_update</span>

    <span class="k">def</span> <span class="nf">union</span><span class="p">(</span><span class="bp">self</span><span class="p">,</span> <span class="o">*</span><span class="n">iterables</span><span class="p">):</span>
        <span class="sd">&quot;&quot;&quot;</span>
<span class="sd">        Return a new SortedSet with elements from the set and all *iterables*.</span>
<span class="sd">        &quot;&quot;&quot;</span>
        <span class="k">return</span> <span class="bp">self</span><span class="o">.</span><span class="vm">__class__</span><span class="p">(</span><span class="n">chain</span><span class="p">(</span><span class="nb">iter</span><span class="p">(</span><span class="bp">self</span><span class="p">),</span> <span class="o">*</span><span class="n">iterables</span><span class="p">),</span> <span class="n">key</span><span class="o">=</span><span class="bp">self</span><span class="o">.</span><span class="n">_key</span><span class="p">,</span> <span class="n">load</span><span class="o">=</span><span class="bp">self</span><span class="o">.</span><span class="n">_load</span><span class="p">)</span>

    <span class="fm">__or__</span> <span class="o">=</span> <span class="n">union</span>
    <span class="fm">__ror__</span> <span class="o">=</span> <span class="fm">__or__</span>

    <span class="k">def</span> <span class="nf">update</span><span class="p">(</span><span class="bp">self</span><span class="p">,</span> <span class="o">*</span><span class="n">iterables</span><span class="p">):</span>
        <span class="sd">&quot;&quot;&quot;Update the set, adding elements from all *iterables*.&quot;&quot;&quot;</span>
        <span class="n">_set</span> <span class="o">=</span> <span class="bp">self</span><span class="o">.</span><span class="n">_set</span>
        <span class="n">values</span> <span class="o">=</span> <span class="nb">set</span><span class="p">(</span><span class="n">chain</span><span class="p">(</span><span class="o">*</span><span class="n">iterables</span><span class="p">))</span>
        <span class="k">if</span> <span class="p">(</span><span class="mi">4</span> <span class="o">*</span> <span class="nb">len</span><span class="p">(</span><span class="n">values</span><span class="p">))</span> <span class="o">&gt;</span> <span class="nb">len</span><span class="p">(</span><span class="n">_set</span><span class="p">):</span>
            <span class="n">_list</span> <span class="o">=</span> <span class="bp">self</span><span class="o">.</span><span class="n">_list</span>
            <span class="n">_set</span><span class="o">.</span><span class="n">update</span><span class="p">(</span><span class="n">values</span><span class="p">)</span>
            <span class="n">_list</span><span class="o">.</span><span class="n">clear</span><span class="p">()</span>
            <span class="n">_list</span><span class="o">.</span><span class="n">update</span><span class="p">(</span><span class="n">_set</span><span class="p">)</span>
        <span class="k">else</span><span class="p">:</span>
            <span class="n">_add</span> <span class="o">=</span> <span class="bp">self</span><span class="o">.</span><span class="n">add</span>
            <span class="k">for</span> <span class="n">value</span> <span class="ow">in</span> <span class="n">values</span><span class="p">:</span>
                <span class="n">_add</span><span class="p">(</span><span class="n">value</span><span class="p">)</span>
        <span class="k">return</span> <span class="bp">self</span>

    <span class="fm">__ior__</span> <span class="o">=</span> <span class="n">update</span>
    <span class="n">_update</span> <span class="o">=</span> <span class="n">update</span>

    <span class="k">def</span> <span class="nf">__reduce__</span><span class="p">(</span><span class="bp">self</span><span class="p">):</span>
        <span class="k">return</span> <span class="p">(</span><span class="bp">self</span><span class="o">.</span><span class="vm">__class__</span><span class="p">,</span> <span class="p">((),</span> <span class="bp">self</span><span class="o">.</span><span class="n">_key</span><span class="p">,</span> <span class="bp">self</span><span class="o">.</span><span class="n">_load</span><span class="p">,</span> <span class="bp">self</span><span class="o">.</span><span class="n">_set</span><span class="p">))</span>

    <span class="nd">@recursive_repr</span>
    <span class="k">def</span> <span class="nf">__repr__</span><span class="p">(</span><span class="bp">self</span><span class="p">):</span>
        <span class="n">temp</span> <span class="o">=</span> <span class="s1">&#39;</span><span class="si">{0}</span><span class="s1">(</span><span class="si">{1}</span><span class="s1">, key=</span><span class="si">{2}</span><span class="s1">, load=</span><span class="si">{3}</span><span class="s1">)&#39;</span>
        <span class="k">return</span> <span class="n">temp</span><span class="o">.</span><span class="n">format</span><span class="p">(</span>
            <span class="bp">self</span><span class="o">.</span><span class="vm">__class__</span><span class="o">.</span><span class="vm">__name__</span><span class="p">,</span>
            <span class="nb">repr</span><span class="p">(</span><span class="nb">list</span><span class="p">(</span><span class="bp">self</span><span class="p">)),</span>
            <span class="nb">repr</span><span class="p">(</span><span class="bp">self</span><span class="o">.</span><span class="n">_key</span><span class="p">),</span>
            <span class="nb">repr</span><span class="p">(</span><span class="bp">self</span><span class="o">.</span><span class="n">_load</span><span class="p">)</span>
        <span class="p">)</span>

    <span class="k">def</span> <span class="nf">_check</span><span class="p">(</span><span class="bp">self</span><span class="p">):</span>
        <span class="c1"># pylint: disable=protected-access</span>
        <span class="bp">self</span><span class="o">.</span><span class="n">_list</span><span class="o">.</span><span class="n">_check</span><span class="p">()</span>
        <span class="k">assert</span> <span class="nb">len</span><span class="p">(</span><span class="bp">self</span><span class="o">.</span><span class="n">_set</span><span class="p">)</span> <span class="o">==</span> <span class="nb">len</span><span class="p">(</span><span class="bp">self</span><span class="o">.</span><span class="n">_list</span><span class="p">)</span>
        <span class="n">_set</span> <span class="o">=</span> <span class="bp">self</span><span class="o">.</span><span class="n">_set</span>
        <span class="k">assert</span> <span class="nb">all</span><span class="p">(</span><span class="n">val</span> <span class="ow">in</span> <span class="n">_set</span> <span class="k">for</span> <span class="n">val</span> <span class="ow">in</span> <span class="bp">self</span><span class="o">.</span><span class="n">_list</span><span class="p">)</span>
</pre></div>

          </div>
        </div>
      </div>
      <div class="sphinxsidebar" role="navigation" aria-label="main navigation">
        <div class="sphinxsidebarwrapper">
<h1 class="logo"><a href="../../index.html">EMULSION</a></h1>



<p class="blurb">Epidemiological Multi-Level Simulation Framework</p>






<h3>Navigation</h3>
<ul>
<li class="toctree-l1"><a class="reference internal" href="../../pages/Information.html">1. Information</a></li>
<li class="toctree-l1"><a class="reference internal" href="../../pages/Install.html">2. Installation</a></li>
<li class="toctree-l1"><a class="reference internal" href="../../pages/Getting_started.html">3. Getting started with EMULSION</a></li>
<li class="toctree-l1"><a class="reference internal" href="../../pages/Modelling_principles.html">4. Modelling principles</a></li>
<li class="toctree-l1"><a class="reference internal" href="../../pages/Modelling_language_basics.html">5. Modelling language (basics)</a></li>
<li class="toctree-l1"><a class="reference internal" href="../../pages/Modelling_language_advanced.html">6. Modelling language (advanced)</a></li>
<li class="toctree-l1"><a class="reference internal" href="../../pages/Feature_examples.html">7. Feature examples</a></li>
<li class="toctree-l1"><a class="reference internal" href="../../pages/Release_notes.html">8. Release notes</a></li>
<li class="toctree-l1"><a class="reference internal" href="../../pages/License.html">9. License</a></li>
<li class="toctree-l1"><a class="reference internal" href="../../emulsion_for_modellers.html">10. High-level functions for model designers</a></li>
<li class="toctree-l1"><a class="reference internal" href="../../emulsion.html">11. emulsion package</a></li>
</ul>

<div class="relations">
<h3>Related Topics</h3>
<ul>
  <li><a href="../../index.html">Documentation overview</a><ul>
  <li><a href="../index.html">Module code</a><ul>
  </ul></li>
  </ul></li>
</ul>
</div>
<div id="searchbox" style="display: none" role="search">
  <h3>Quick search</h3>
    <div class="searchformwrapper">
    <form class="search" action="../../search.html" method="get">
      <input type="text" name="q" />
      <input type="submit" value="Go" />
      <input type="hidden" name="check_keywords" value="yes" />
      <input type="hidden" name="area" value="default" />
    </form>
    </div>
</div>
<script type="text/javascript">$('#searchbox').show(0);</script>
        </div>
      </div>
      <div class="clearer"></div>
    </div>
    <div class="footer">
      &copy;2016, INRAE and Univ. Lille.
      
      |
      Powered by <a href="http://sphinx-doc.org/">Sphinx 1.8.5</a>
      &amp; <a href="https://github.com/bitprophet/alabaster">Alabaster 0.7.10</a>
      
    </div>

    

    
  </body>
</html>